<template>
  <div class="app-container">
    <div class="operation">
      <el-button
        v-if="isRoleEdit"
        class="success"
        icon="el-icon-plus"
        style="float: left"
        @click="handleCreate"
        >{{ $t('premixedPlan.xzcc') }}
      </el-button>
      <el-button
        v-if="isRoleEdit"
        class="danger"
        icon="el-icon-delete"
        style="float: left"
        @click="form_delete"
        >{{ $t('premixedPlan.jscc') }}
      </el-button>
      <el-button
        v-if="isRoleEdit"
        class="success"
        style="float: left"
        @click="handleCheck"
        >{{ $t('premixedPlan.jy1') }}
      </el-button>
      <el-button
        v-if="isOrder && isRoleEdit"
        icon="el-icon-sort"
        style="float: left"
        class="success"
        @click="handleChangeOrder"
        >{{ $t('formulationEvaluation.ggsx') }}</el-button
      >
      <div v-else style="float: left; margin-left: 10px">
        <el-button
          v-if="isRoleEdit"
          icon="el-icon-folder-checked"
          class="success"
          @click="saveChangeOrder"
          >{{ $t('premixedPlan.save') }}
        </el-button>
        <el-button
          v-if="isRoleEdit"
          icon="el-icon-close"
          class="sortCancel"
          @click="cancelChangeOrder"
          >{{ $t('formulationEvaluation.cancel') }}</el-button
        >
      </div>
      <el-button
        v-if="isRoleEdit"
        class="success"
        icon="el-icon-open"
        style="float: left"
        @click="handleTakeEffect"
        >{{ $t('premixedPlan.sx') }}
      </el-button>
      <el-button
        v-if="isRoleEdit"
        class="danger"
        icon="el-icon-turn-off"
        style="float: left"
        @click="handleDisable"
        >{{ $t('premixedPlan.jy') }}
      </el-button>
      <el-button
        class="import"
        style="float: right"
        @click="handleHistoryRecords"
        >{{ $t('dhedFormula.lsjl') }}</el-button
      >
    </div>
    <div class="search" />
    <div class="table">
      <el-table
        id="table"
        :key="table.tableKey"
        v-loading="table.listLoading"
        :element-loading-text="$t('common.tableMsg')"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        row-key="id"
        @selection-change="handleSelect"
      >
        <el-table-column type="selection" min-width="50" />
        <el-table-column
          :label="$t('errorAnalysis.projname')"
          min-width="80px"
          align="center"
        >
          <template slot-scope="scope">
            <span>{{ scope.row.sort }}</span>
          </template>
        </el-table-column>
        <el-table-column
          :label="$t('errorAnalysis.pen')"
          min-width="110px"
          align="center"
        >
          <template slot-scope="scope">
            <span>{{ scope.row.qstr }}</span>
          </template>
        </el-table-column>
        <el-table-column
          :label="$t('premixedPlan.tmrbh')"
          prop="weight"
          min-width="110px"
          align="center"
        >
          <template slot-scope="scope">
            <span>{{ scope.row.tmrcode }}</span>
          </template>
        </el-table-column>
        <el-table-column
          :label="$t('premixedPlan.sx')"
          min-width="70px"
          align="center"
        >
          <template slot-scope="scope">
            <el-switch
              v-model="scope.row.enable"
              :disabled="scope.row.NoEdit == true"
              active-color="#13ce66"
              inactive-color="#ff4949"
              :active-value="1"
              :inactive-value="0"
            />
          </template>
        </el-table-column>
        <el-table-column
          :label="$t('errorAnalysis.isTrainNumber')"
          min-width="120px"
          align="center"
        >
          <template slot-scope="scope">
            <span>{{ scope.row.times }}</span>
          </template>
        </el-table-column>
        <el-table-column
          :label="$t('premixedPlan.sljhccgs')"
          min-width="90px"
          align="center"
        >
          <template slot-scope="scope">
            <span>{{ scope.row.lppcode }}</span>
          </template>
        </el-table-column>

        <el-table-column
          :label="$t('premixedPlan.slclfs')"
          min-width="130px"
          align="center"
        >
          <template slot-scope="scope">
            <span>{{ scope.row.treatmethod }}</span>
          </template>
        </el-table-column>
        <el-table-column
          :label="$t('premixedPlan.ztls')"
          min-width="130px"
          align="center"
        >
          <template slot-scope="scope">
            <span>{{ scope.row.hstr }}</span>
          </template>
        </el-table-column>
        <!-- <el-table-column  :label="$t('errorAnalysis.cz')" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="row.isCreate && isRoleEdit" :disabled="isokDisable" icon="el-icon-folder-checked" class="miniSuccess" @click="createData(row)" />
            <span v-if="row.isCreate && isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="row.isCreate && isRoleEdit" class="minCancel" icon="el-icon-close" @click="createCancel(row)" />
            <el-button v-if="row.isUpdate && isRoleEdit" class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <span v-if="row.isUpdate && isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="row.isUpdate && isRoleEdit" class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
            <el-button v-if="row.isUpdateSave && isRoleEdit" :disabled="isokDisable" icon="el-icon-folder-checked" class="miniSuccess" @click="updateData(row)" />
            <span v-if="row.isUpdateSave && isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="row.isUpdateSave && isRoleEdit" class="minCancel" icon="el-icon-close" @click="updateCancel(row)" />
          </template>
        </el-table-column> -->
        <el-table-column
          :label="$t('errorAnalysis.cz')"
          align="center"
          width="180"
          class-name="small-padding fixed-width"
          fixed="right"
        >
          <template slot-scope="{ row }">
            <!-- <span v-if="isRoleEdit" class="centerSpan">|</span> -->
            <el-button
              v-if="isRoleEdit"
              icon="el-icon-edit-outline"
              class="miniSuccess"
              @click="handleUpdate(row)"
            />
            <span v-if="isRoleEdit" class="centerSpan">|</span>
            <el-button
              v-if="isRoleEdit"
              icon="el-icon-delete"
              class="miniDanger"
              @click="handleRowDelete(row)"
            />
          </template>
        </el-table-column>
      </el-table>
      <span
        v-if="table.listLoading == false"
        style="margin-right: 30px; margin-top: 10px; font-size: 14px"
        >{{ $t('processAnalysis.total') }}{{ table.total
        }}{{ $t('processAnalysis.tiao') }}</span
      >
    </div>

    <!-- 新增/编辑 -->
    <el-dialog
      :fullscreen="dialogFull"
      :visible.sync="create.dialogFormVisible"
      :close-on-click-modal="false"
      width="90%"
    >
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span
              style="
                display: inline-block;
                width: 3px;
                height: 20px;
                margin-right: 5px;
                float: left;
                margin-top: 2px;
              "
            />
            {{ textMap[create.dialogStatus] }}
          </span>
          <div
            class="avue-crud__dialog__menu"
            @click="dialogFull ? (dialogFull = false) : (dialogFull = true)"
          >
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="app-add">
        <el-form
          ref="temp"
          :rules="create.rules"
          :model="create.temp"
          label-position="right"
          label-width="155px"
          style="width: 100%; margin: 0 auto 50px"
        >
          <el-row>
            <el-col :span="6">
              <el-form-item :label="$t('premixedPlan.cci')" prop="sort">
                <el-input
                  ref="sort"
                  v-model="create.temp.sort"
                  class="filter-item"
                  type="number"
                  :placeholder="$t('errorAnalysis.projname')"
                />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('premixedPlan.lsname')" prop="barid">
                <el-select
                  v-model="create.temp.barid"
                  multiple
                  filterable
                  :placeholder="$t('errorAnalysis.isHouseName')"
                  class="filter-item"
                  style="width: 100%"
                  @change="changeBars"
                >
                  <el-option
                    v-for="item in barsList"
                    :key="item.id"
                    :label="item.bname"
                    :value="item.id"
                  />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="TMR编号：" prop="tmrid">
                <el-select
                  v-model="create.temp.tmrid"
                  filterable
                  :placeholder="$t('premixedPlan.tmrbh')"
                  class="filter-item"
                  style="width: 100%"
                  @change="changeTMRNumber"
                >
                  <el-option
                    v-for="item in TMRNumberList"
                    :key="item.id"
                    :label="item.eqcode"
                    :value="item.id"
                  />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('premixedPlan.sx')" prop="sort">
                <el-switch
                  ref="enable"
                  v-model="create.temp.enable"
                  active-color="#13ce66"
                  inactive-color="#ff4949"
                  :active-value="1"
                  :inactive-value="0"
                />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item :label="$t('premixedPlan.bc')" prop="times">
                <el-select
                  v-model="create.temp.times"
                  filterable
                  :placeholder="$t('premixedPlan.bc')"
                  class="filter-item"
                  style="width: 100%"
                  @change="changeTimes"
                >
                  <el-option
                    v-for="item in frequencyList"
                    :key="item.id"
                    :label="item.name"
                    :value="item.id"
                  />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('premixedPlan.sljhccgs')" prop="lppid">
                <el-select
                  v-model="create.temp.lppid"
                  filterable
                  :placeholder="$t('premixedPlan.sljhccgs')"
                  class="filter-item"
                  style="width: 100%"
                  @change="changeCarFollow"
                >
                  <el-option
                    v-for="item in carFollowList"
                    :key="item.id"
                    :label="item.lppcode"
                    :value="item.id"
                  />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item :label="$t('premixedPlan.time')" prop="rtime">
                <el-time-picker
                  v-model="create.temp.rtime"
                  type="datetime"
                  :placeholder="$t('dailyExecutionPlan.xzrq')"
                  format="HH:mm"
                  value-format="HH:mm"
                  style="display: inline-block; width: 95%"
                />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item
                :label="$t('premixedPlan.slclfs')"
                prop="treatmethod"
              >
                <el-select
                  v-model="create.temp.treatmethod"
                  filterable
                  :placeholder="$t('premixedPlan.slclfs')"
                  class="filter-item"
                  style="width: 100%"
                  @change="changeResidueDisposal"
                >
                  <el-option
                    v-for="item in residueDisposalList"
                    :key="item.value"
                    :label="item.label"
                    :value="item.label"
                  />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item :label="$t('premixedPlan.ztls')" prop="useinbarid">
                <el-select
                  v-model="create.temp.useinbarid"
                  filterable
                  :placeholder="$t('premixedPlan.ztls')"
                  class="filter-item"
                  style="width: 100%"
                  @change="changeTransferbars"
                  :disabled="isDis"
                >
                  <el-option
                    v-for="item in transferbarsList"
                    :key="item.id"
                    :label="item.bname"
                    :value="item.id"
                  />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <draggable
              v-model="barSortList"
              group="itxst"
              animation="300"
              :group="{ name: 'dashboard', pull: true }"
              @start="onStart"
              @end="onEnd"
            >
              <transition-group>
                <div
                  style="
                    width: 80px;
                    height: 30px;
                    border: 1px soild #333;
                    display: inline-block;
                    background: #2ed1f9;
                    padding: 5px 5px;
                    margin-right: 15px;
                    margin-bottom: 15px;
                  "
                  v-for="item in barSortList"
                  key="1"
                >
                  {{ item.bname }}
                </div>
              </transition-group>
            </draggable>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button
            class="cancelClose"
            @click="
              create.dialogFormVisible = false
              getList()
            "
            >{{ $t('common.closed') }}</el-button
          >
          <el-button
            v-if="
              create.dialogStatus === 'create' ||
              create.dialogStatus === 'update'
            "
            class="save"
            :disabled="isokDisable"
            @click="
              create.dialogStatus === 'create' ? createData() : updateData()
            "
            >{{ $t('errorAnalysis.confirm') }}</el-button
          >
        </div>
      </div>
    </el-dialog>
    <!-- 历史记录 -->
    <el-dialog
      :fullscreen="dialogFull"
      :destroy-on-close="true"
      :visible.sync="history.dialogFormVisible"
      :close-on-click-modal="false"
      width="90%"
    >
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span
              style="
                display: inline-block;
                width: 3px;
                height: 20px;
                margin-right: 5px;
                float: left;
                margin-top: 2px;
              "
            />
            {{ textMap[history.dialogStatus] }}
          </span>
          <div
            class="avue-crud__dialog__menu"
            @click="dialogFull ? (dialogFull = false) : (dialogFull = true)"
          >
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="app-history">
        <div class="search">
          <el-date-picker
            v-model="history.getdataListParm.parammaps.date"
            type="date"
            placeholder="请选择历史记录时间"
            :clearable="false"
            style="width: 180px"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            @change="changeDate"
          />
          <!-- <el-button class="successBorder" @click="handleApplication">{{$t('message.msg304')}}</el-button> -->
        </div>
        <div class="table">
          <el-table
            :key="history.tableKey"
            v-loading="history.listLoading"
            :element-loading-text="$t('common.tableMsg')"
            :data="history.list"
            border
            fit
            highlight-current-row
            style="width: 100%"
            :row-style="rowStyle"
            :cell-style="cellStyle"
            class="elTable table-fixed"
          >
            <el-table-column
              :label="$t('errorAnalysis.projname')"
              min-width="130px"
              align="center"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.sort }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('errorAnalysis.pen')"
              min-width="130px"
              align="center"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.qstr }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('premixedPlan.tmrbh')"
              prop="weight"
              min-width="130px"
              align="center"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.tmrcode }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('premixedPlan.sx')"
              min-width="130px"
              align="center"
            >
              <template slot-scope="scope">
                <el-switch
                  v-model="scope.row.enable"
                  disabled
                  active-color="#13ce66"
                  inactive-color="#ff4949"
                  :active-value="1"
                  :inactive-value="0"
                  @change="handleEnableChange(scope.$index, scope.row)"
                />
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('errorAnalysis.isTrainNumber')"
              min-width="130px"
              align="center"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.times }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('premixedPlan.fljhcsgs')"
              min-width="130px"
              align="center"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.lppcode }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('premixedPlan.time')"
              min-width="180px"
              align="center"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.rtime }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('premixedPlan.slclfs')"
              min-width="130px"
              align="center"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.treatmethod }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('premixedPlan.ztls')"
              min-width="130px"
              align="center"
            >
              <template slot-scope="scope">
                <span>{{ scope.row.hstr }}</span>
              </template>
            </el-table-column>
          </el-table>
          <pagination
            v-show="history.total > 0"
            :total="history.total"
            :page.sync="history.getdataListParm.offset"
            :limit.sync="history.getdataListParm.pagecount"
            @pagination="getHistoryList"
          />
        </div>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button
          class="cancelClose cancelClose1"
          @click="history.dialogFormVisible = false"
          >{{ $t('common.closed') }}</el-button
        >
      </div>
    </el-dialog>

    <!-- 校验 -->
    <el-dialog
      :title="textMap[check.dialogStatus]"
      :destroy-on-close="true"
      :visible.sync="check.dialogFormVisible"
      :close-on-click-modal="false"
      width="30%"
    >
      <div class="check">
        <p v-if="check.temp.isDistribution == '0'">
          {{ $t('message.msg292') }}
        </p>
        <p v-else>{{ $t('message.msg293') }}</p>
        {{ check.temp.bnames }}
      </div>
      <div slot="footer" class="dialog-footer" style="bottom: 10px">
        <el-button class="save" @click="check.dialogFormVisible = false">{{
          $t('errorAnalysis.confirm')
        }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  GetDataByName,
  GetDataByNames,
  PostDataByName,
  failproccess,
  ExecDataByConfig,
  checkButtons,
  postJson2
} from '@/api/common'
import { parseTime } from '@/utils/index.js'
import Pagination from '@/components/Pagination'
import Sortable from 'sortablejs'
import draggable from 'vuedraggable'
import Cookies from 'js-cookie'
import { MessageBox } from 'element-ui'
export default {
  name: 'SurplusMaterialPlan',
  components: {
    Pagination,
    draggable
  },
  data() {
    return {
      barSortList: [],
      dialogFull: false,
      isDis: false,
      isRoleEdit: [],
      requestParams: [
        {
          name: 'getBarListEnable',
          offset: 0,
          pagecount: 0,
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        {
          name: 'getTMRYHList',
          offset: 0,
          pagecount: 0,
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        }
      ],
      barsList: [], // 栏舍
      residueDisposalList: [
        {
          value: '0',
          label: this.$t('message.msg294')
        },
        {
          value: '1',
          label: this.$t('message.msg295')
        }
      ], // 剩料处理方式
      TMRNumberList: [], // TMR编号
      barsNamesIdTempArr: [],
      useinbarNamesIdTempArr: [],
      // 班次
      maxTime: {
        getMaxTimesParm: {
          name: 'getSysoptEnable',
          page: 1,
          offset: 1,
          pagecount: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            inforname: 'times'
          }
        }
      },
      frequencyList: [], // 班次
      getCarFollowParm: {
        name: 'getLPPCodeList',
        offset: 0,
        pagecount: 0,
        parammaps: {
          pastureid: Cookies.get('pastureid'),
          times: ''
        }
      },
      carFollowList: [], // 发料计划车次跟随
      getTransferbarsParm: {
        name: 'getBarListEnable',
        offset: 0,
        pagecount: 0,
        parammaps: {
          pastureid: Cookies.get('pastureid'),
          times: ''
        }
      },
      transferbarsList: [], // 转头栏舍
      table: {
        getdataListParm: {
          name: 'getRemainplanList',
          page: 1,
          offset: 1,
          pagecount: '',
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {},
        temp2: {}
      },

      // 新增/编辑
      create: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: {
          pastureid: Cookies.get('pastureid'),
          fname: '',
          fclassid: '',
          fclass: '',
          feedcode: '',
          source: this.$t('message.msg313'),
          printgroupid: '1',
          printgroup: '无',
          unitweight: '',
          uprice: '',
          allowratio: '',
          autozone: '',
          autosecond: '0',
          autosecondname: '禁用',
          confirmstart: '0',
          confirmstartname: '禁用',
          enable: '1',
          trgaddress: '',
          backup1: '',
          backup2: '',
          backup3: '',
          sort: ''
        },
        rules: {
          // fname: [{ type: 'string', required: true, message: this.$t('hardwareTest.bt'), trigger: 'blur' }],
          // fclassid: [{ type: 'string', required: true, message: this.$t('hardwareTest.bt'), trigger: 'blur' }],
          // feedcode: [{ type: 'string', required: true, message: this.$t('hardwareTest.bt'), trigger: 'blur' }]
        }
      },

      history: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: {},
        rules: {},
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,

        getdataDateParm: {
          name: 'getRPMaxDate',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        getdataListParm: {
          name: 'getRemainplanListDate',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            date: ''
          }
        }
      },
      check: {
        dialogFormVisible: false,
        dialogStatus: '',
        getCheckParm: {
          name: 'checkRemainplan',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        temp: {
          bnames: '',
          isDistribution: ''
        }
      },
      textMap: {
        create: this.$t('message.msg291'),
        update: this.$t('message.msg290'),
        history: this.$t('message.msg34'),
        check: this.$t('message.msg111')
      },
      requestParam: {},
      selectList: [],
      isokDisable: false,
      rowStyle: {
        maxHeight: 30 + 'px',
        height: 30 + 'px'
      },
      cellStyle: {
        padding: 0 + 'px'
      },
      dropState: false,
      isOrder: true
    }
  },
  created() {
    this.getButtons()
    this.getList()
    this.getDownList()
    this.getIsDisplay()
  },
  methods: {
    getButtons() {
      const Edit = 'SurplusMaterialPlan'
      const isRoleEdit = checkButtons(
        JSON.parse(sessionStorage.getItem('buttons')),
        Edit
      )
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then((response) => {
        this.barsList = response.data.getBarListEnable.list
        this.TMRNumberList = response.data.getTMRYHList.list
      })
    },
    getIsDisplay() {
      GetDataByName(this.maxTime.getMaxTimesParm).then((response) => {
        if (response.data.list[0].inforvalue == 1) {
          this.frequencyList = [
            {
              id: '1',
              name: this.$t('errorAnalysis.one')
            }
          ]
        } else if (response.data.list[0].inforvalue == 2) {
          this.frequencyList = [
            {
              id: '1',
              name: this.$t('errorAnalysis.one')
            },
            {
              id: '2',
              name: this.$t('errorAnalysis.two')
            }
          ]
        } else if (response.data.list[0].inforvalue == 3) {
          this.frequencyList = [
            {
              id: '1',
              name: this.$t('errorAnalysis.one')
            },
            {
              id: '2',
              name: this.$t('errorAnalysis.two')
            },
            {
              id: '3',
              name: this.$t('errorAnalysis.three')
            }
          ]
        } else if (response.data.list[0].inforvalue == 4) {
          this.frequencyList = [
            {
              id: '1',
              name: this.$t('errorAnalysis.one')
            },
            {
              id: '2',
              name: this.$t('errorAnalysis.two')
            },
            {
              id: '3',
              name: this.$t('errorAnalysis.three')
            },
            {
              id: '4',
              name: this.$t('errorAnalysis.four')
            }
          ]
        } else if (response.data.list[0].inforvalue == 5) {
          this.frequencyList = [
            {
              id: '1',
              name: this.$t('errorAnalysis.one')
            },
            {
              id: '2',
              name: this.$t('errorAnalysis.two')
            },
            {
              id: '3',
              name: this.$t('errorAnalysis.three')
            },
            {
              id: '4',
              name: this.$t('errorAnalysis.four')
            },
            {
              id: '5',
              name: this.$t('errorAnalysis.five')
            }
          ]
        } else if (response.data.list[0].inforvalue == 6) {
          this.frequencyList = [
            {
              id: '1',
              name: this.$t('errorAnalysis.one')
            },
            {
              id: '2',
              name: this.$t('errorAnalysis.two')
            },
            {
              id: '3',
              name: this.$t('errorAnalysis.three')
            },
            {
              id: '4',
              name: this.$t('errorAnalysis.four')
            },
            {
              id: '5',
              name: this.$t('errorAnalysis.five')
            },
            {
              id: '6',
              name: this.$t('errorAnalysis.six')
            }
          ]
        }
      })
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then((response) => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'Edit', false) // 编辑
            this.$set(response.data.list[i], 'NoEdit', true) // 不可编辑/输入
            this.$set(response.data.list[i], 'groupEdit', false) // 饲料组编辑
            this.$set(response.data.list[i], 'groupNoEdit', true) // 饲料组不可编辑
            this.$set(response.data.list[i], 'isCreate', false) // 新增操作
            this.$set(response.data.list[i], 'isUpdate', true) // 编辑操作
            this.$set(response.data.list[i], 'isUpdateSave', false) // 编辑保存
          }
          var arr = response.data.list

          arr.map(function (i, j) {
            // console.log(i, '====')
            if (i.qstrids) {
              return (i.barid = i.qstrids.split(','))
            } else {
              return (i.barid = [])
            }
          })

          arr.map(function (i, j) {
            if (i.hstrids) {
              return (i.useinbarid = i.hstrids)
            } else {
              return (i.useinbarid = '')
            }
          })

          this.table.list = arr
          // this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          // this.rowDrop()
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }

        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    handleEnableChange() {
      console.log('点击了生效')
    },
    handleChangeOrder() {
      this.isOrder = false
      this.rowDrop()
    },
    saveChangeOrder() {
      // 保存顺序
      var sortArr = []
      for (let i = 0; i < this.table.list.length; i++) {
        var obj = {}
        obj.sort = i + 1
        obj.id = this.table.list[i].id
        obj.pastureid = this.table.list[i].pastureid
        sortArr.push(obj)
      }
      this.requestParam = {}
      this.requestParam.common = {
        returnmap: '0'
      }
      this.requestParam.data = []
      this.requestParam.data[0] = {
        name: 'insertSpotList',
        resultmaps: {
          list: sortArr
        }
      }
      this.requestParam.data[0].children = []
      this.requestParam.data[0].children[0] = {
        name: 'updateRemainplanSort',
        type: 'e',
        parammaps: {
          id: '@insertSpotList.id',
          pastureid: '@insertSpotList.pastureid',
          sort: '@insertSpotList.sort'
        }
      }
      ExecDataByConfig(this.requestParam).then((response) => {
        console.log('顺序切换保存发送参数', this.requestParam)
        if (response.msg === 'fail') {
          this.$notify({
            title: this.$t('message.msg51'),
            message: response.data,
            type: 'warning',
            duration: 2000
          })
        } else {
          this.$notify({
            title: '',
            message: this.$t('message.msg50'),
            type: 'success',
            duration: 2000
          })
          this.getList()
          this.isOrder = true
        }
      })
    },
    cancelChangeOrder() {
      // 取消顺序
      this.getList()
      this.isOrder = true
    },
    // 行拖拽
    rowDrop() {
      console.log(
        document.querySelector('#table .el-table__body-wrapper tbody')
      )
      const tbody = document.querySelector(
        '#table .el-table__body-wrapper tbody'
      )
      const that = this
      var sortable = Sortable.create(tbody, {
        disabled: that.dropState,
        onChoose({ newIndex, oldIndex }) {
          if (that.dropState == true) {
            sortable.destroy()
          }
        },
        onEnd({ newIndex, oldIndex }) {
          const currRow = that.table.list.splice(oldIndex, 1)[0]
          that.table.list.splice(newIndex, 0, currRow)
          console.log('索引', newIndex)
          console.log('拖动数据', currRow)
          console.log('上', that.table.list[newIndex - 1])
          console.log('下', that.table.list[newIndex + 1])
        }
      })
    },

    // 新增
    handleCreate() {
      console.log('点击了新增')
      this.resetTemp()
      this.dialogFull = false
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
    },

    resetTemp() {
      this.create.temp = {
        pastureid: Cookies.get('pastureid'),
        myId: new Date().valueOf(),
        Edit: true,
        NoEdit: false,
        isCreate: true,
        isUpdate: false,
        isUpdateSave: false,
        enable: 1,
        sort: '',
        ftid: '',
        ftname: '',
        tmrcode: '',
        tmrid: '',
        times: '',
        lppcode: '',
        lppid: '',
        rtime: '',
        barid: '',
        treatmethod: '',
        useinbar: '',
        useinbarid: ''
      }
      this.barSortList = []
      this.isDis = false
    },

    // // 栏舍
    // changeBars(val) {
    //   console.log('点击了栏舍', val)
    //   var arr = []
    //   this.barsList.forEach(function(i) {
    //     val.forEach(function(j) {
    //       if (i.id == j) { arr.push(i) }
    //     })
    //   })
    //   console.log('点击了栏舍', arr)
    //   this.table.temp.barid = arr
    //   this.barsNamesIdTempArr = arr
    //   this.$forceUpdate()
    // },

    changeBars(val) {
      console.log(this.barsList)
      console.log('点击了栏舍1', val)
      var barSortList = []

      var barsList = this.barsList
      val.forEach(function (i) {
        barsList.forEach(function (j) {
          if (i == j.id) {
            barSortList.push(j)
          }
        })
      })
      this.barSortList = barSortList

      console.log('点击了栏舍1', barSortList)

      this.table.temp.barid = barSortList
      this.barsNamesIdTempArr = barSortList
      this.$forceUpdate()
    },

    onStart() {
      console.log(2222)
    },
    onEnd() {
      console.log(this.barSortList)

      this.table.temp.barid = this.barSortList
      this.barsNamesIdTempArr = this.barSortList
    },
    // // TMR编号
    // changeTMRNumber(item, row) {
    //   row.tmrcode = this.TMRNumberList.find(obj => obj.id == item).tname
    // },

    changeTMRNumber(item) {
      this.create.temp.tmrcode = this.TMRNumberList.find(
        (obj) => obj.id === item
      ).eqcode
    },
    // // 撒料计划车次跟随列表
    // changeCarFollow(item, row) {
    //   if (item == '') {
    //     row.lppcode = ''
    //   } else {
    //     row.lppcode = this.carFollowList.find(obj => obj.id == item).lppcode
    //   }
    // },

    changeCarFollow(item, row) {
      if (item == '') {
        this.create.temp.lppcode = ''
      } else {
        this.create.temp.lppcode = this.carFollowList.find(
          (obj) => obj.id == item
        ).lppcode
      }
    },
    // 班次
    // changeTimes(item, row) {
    //   console.log(item, row)
    //   this.getCarFollowParm.parammaps.times = item
    //   this.getCarFollowList(row)
    // },

    // 班次
    changeTimes(item) {
      console.log(item)
      this.getCarFollowParm.parammaps.times = item

      this.getCarFollowList()
    },
    // 撒料计划车次跟随列表
    // getCarFollowList(row) {
    //   GetDataByName(this.getCarFollowParm).then(response => {
    //     console.log('撒料计划车次跟随列表数据', response.data.list)
    //     if (response.data.list !== null) {
    //       this.carFollowList = response.data.list
    //       row.lppid = this.carFollowList[0].id
    //       row.lppcode = this.carFollowList[0].lppcode
    //     }
    //   })
    // },
    getCarFollowList() {
      GetDataByName(this.getCarFollowParm).then((response) => {
        console.log('撒料计划车次跟随列表数据', response.data.list)
        if (response.data.list !== null) {
          this.carFollowList = response.data.list
          this.create.temp.lppid = this.carFollowList[0].id
          this.create.temp.lppcode = this.carFollowList[0].lppcode
        }
      })
    },

    // changeResidueDisposal(item, row) {
    //   console.log(item, row)
    //   this.getCarFollowParm.parammaps.times = item
    //   this.getTransferbarsList()
    // },
    changeResidueDisposal(item) {
      console.log(item)
      this.getCarFollowParm.parammaps.times = item
      this.getTransferbarsList()

      if (item == '继续饲喂') {
        this.isDis = true
      } else {
        this.isDis = false
      }
    },
    getTransferbarsList() {
      GetDataByName(this.getTransferbarsParm).then((response) => {
        if (response.data.list !== null) {
          this.transferbarsList = response.data.list
        }
        console.log(this.transferbarsList)
      })
    },
    // // 转头栏舍
    // changeTransferbars(val) {
    //   console.log('点击了转头栏舍', val)
    //   var arr2 = []
    //   this.transferbarsList.forEach(function(i) {
    //     val.forEach(function(j) {
    //       if (i.id == j) { arr2.push(i) }
    //     })
    //   })
    //   this.table.temp2.useinbar = arr2
    //   this.useinbarNamesIdTempArr = arr2
    //   this.$forceUpdate()
    // },

    // 转头栏舍
    changeTransferbars(val) {
      console.log('点击了转头栏舍', val)
      // var arr2 = []
      // this.transferbarsList.forEach(function(i) {
      //   val.forEach(function(j) {
      //     if (i.id == j) { arr2.push(i) }
      //   })
      // })
      // this.table.temp2.useinbar = arr2
      // // this.useinbarNamesIdTempArr = arr2
      // this.$forceUpdate()
    },

    // createData(row) {
    //   console.log('点击了新增保存', row)
    //   if (row.rtime == null || row.rtime == 'null') {
    //     row.rtime = ''
    //   }
    //   if (row.sort == '' && row.barid == '' && row.tmrid == '' && row.times == '' && row.treatmethod == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg182'), duration: 2000 })
    //     return false
    //   } else if (row.barid == '' && row.tmrid == '' && row.times == '' && row.treatmethod == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg183'), duration: 2000 })
    //     return false
    //   } else if (row.tmrid == '' && row.times == '' && row.treatmethod == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg184'), duration: 2000 })
    //     return false
    //   } else if (row.times == '' && row.treatmethod == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg185'), duration: 2000 })
    //     return false
    //   } else if (row.sort == '' || row.sort == 0) {
    //     this.$message({ type: 'error', message:  this.$t('message.msg146'), duration: 2000 })
    //     return false
    //   } else if (row.barid == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg186'), duration: 2000 })
    //     return false
    //   } else if (row.tmrid == '') {
    //     this.$message({ type: 'error', message:  this.$t('message.msg147'), duration: 2000 })
    //     return false
    //   } else if (row.times == '') {
    //     this.$message({ type: 'error', message:  this.$t('message.msg148'), duration: 2000 })
    //     return false
    //   } else if (row.treatmethod == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg187'), duration: 2000 })
    //     return false
    //   }
    //   if (row.treatmethod !== '' && row.treatmethod == '转投剩料') {
    //     if (row.useinbarid == '') {
    //       this.$message({ type: 'error', message: this.$t('message.msg188'), duration: 2000 })
    //       return false
    //     }
    //   }
    //   if (row.treatmethod !== '' && row.treatmethod == '继续饲喂') {
    //     row.useinbarid = '0'
    //   }
    //   if (row.rtime == '' || row.rtime == null) {
    //     row.rtime = ''
    //   }
    //   for (let i = 0; i < this.table.list.length; i++) {
    //     if (row.sort == this.table.list[i].sort) {
    //       if (row.myId !== this.table.list[i].myId) {
    //         this.$message({ type: 'error', message:  this.$t('message.msg150'), duration: 2000 })
    //         return false
    //       }
    //     }
    //   }

    //   var isInteger = /^\d+$/
    //   if (row.sort !== '') {
    //     if (!isInteger.test(parseFloat(row.sort))) {
    //       this.$message({ type: 'error', message:  this.$t('message.msg151'), duration: 2000 })
    //       return false
    //     }
    //   }
    //   this.isokDisable = true
    //   setTimeout(() => {
    //     this.isokDisable = false
    //   }, 1000)
    //   this.requestParam.common = { 'returnmap': '0' }
    //   this.requestParam.data = []
    //   this.requestParam.data[0] = { 'name': 'insertRemainplan', 'type': 'e', 'parammaps': {
    //     pastureid: Cookies.get('pastureid'),
    //     sort: row.sort,
    //     tmrid: row.tmrid,
    //     tmrcode: row.tmrcode,
    //     enable: row.enable,
    //     times: row.times,
    //     lppid: row.lppid,
    //     lppcode: row.lppcode,
    //     rtime: row.rtime,
    //     treatmethod: row.treatmethod
    //   }}
    //   this.requestParam.data[1] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.barsNamesIdTempArr }}
    //   this.requestParam.data[1].children = []
    //   this.requestParam.data[1].children[0] = { 'name': 'insertRpdetail', 'type': 'e', 'parammaps': {
    //     pastureid: Cookies.get('pastureid'),
    //     bigid: '@insertRemainplan.LastInsertId',
    //     barid: '@insertSpotList.id',
    //     bar: '@insertSpotList.bname',
    //     type: 0
    //   }}
    //   this.requestParam.data[2] = { 'name': 'insertSpotList2', 'resultmaps': { 'list': this.useinbarNamesIdTempArr }}
    //   this.requestParam.data[2].children = []
    //   this.requestParam.data[2].children[0] = { 'name': 'insertRpdetail', 'type': 'e', 'parammaps': {
    //     pastureid: Cookies.get('pastureid'),
    //     bigid: '@insertRemainplan.LastInsertId',
    //     barid: '@insertSpotList2.id',
    //     bar: '@insertSpotList2.bname',
    //     type: 1
    //   }}
    //   ExecDataByConfig(this.requestParam).then(response => {
    //     console.log('新增保存发送参数', this.requestParam)
    //     if (response.msg === 'fail') {
    //       this.$notify({ title: this.$t('driver.saveFail'), message: response.data, type: 'warning', duration: 2000 })
    //     } else {
    //       this.$notify({ title: this.$t('common.succes'), message: this.$t('driver.saveSuccess'), type: 'success', duration: 2000 })
    //       this.getList()
    //       this.dropState = false
    //     }
    //   })
    // },

    createData() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate((valid) => {
        if (valid) {
          if (
            this.create.temp.rtime == null ||
            this.create.temp.rtime == 'null'
          ) {
            this.create.temp.rtime = ''
          }
          if (
            this.create.temp.sort == '' &&
            this.create.temp.barid == '' &&
            this.create.temp.tmrid == '' &&
            this.create.temp.times == '' &&
            this.create.temp.treatmethod == ''
          ) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg182'),
              duration: 2000
            })
            return false
          } else if (
            this.create.temp.barid == '' &&
            this.create.temp.tmrid == '' &&
            this.create.temp.times == '' &&
            this.create.temp.treatmethod == ''
          ) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg183'),
              duration: 2000
            })
            return false
          } else if (
            this.create.temp.tmrid == '' &&
            this.create.temp.times == '' &&
            this.create.temp.treatmethod == ''
          ) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg184'),
              duration: 2000
            })
            return false
          } else if (
            this.create.temp.times == '' &&
            this.create.temp.treatmethod == ''
          ) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg185'),
              duration: 2000
            })
            return false
          } else if (
            this.create.temp.sort == '' ||
            this.create.temp.sort == 0
          ) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg146'),
              duration: 2000
            })
            return false
          } else if (this.create.temp.barid == '') {
            this.$message({
              type: 'error',
              message: this.$t('message.msg186'),
              duration: 2000
            })
            return false
          } else if (this.create.temp.tmrid == '') {
            this.$message({
              type: 'error',
              message: this.$t('message.msg147'),
              duration: 2000
            })
            return false
          } else if (this.create.temp.times == '') {
            this.$message({
              type: 'error',
              message: this.$t('message.msg148'),
              duration: 2000
            })
            return false
          } else if (this.create.temp.treatmethod == '') {
            this.$message({
              type: 'error',
              message: this.$t('message.msg187'),
              duration: 2000
            })
            return false
          }
          if (
            this.create.temp.treatmethod !== '' &&
            this.create.temp.treatmethod == '转投剩料'
          ) {
            if (this.create.temp.useinbarid == '') {
              this.$message({
                type: 'error',
                message: this.$t('message.msg188'),
                duration: 2000
              })
              return false
            }
          }
          if (
            this.create.temp.treatmethod !== '' &&
            this.create.temp.treatmethod == '继续饲喂'
          ) {
            // this.create.temp.useinbarid = '0'
            this.create.temp.useinbarid = '0'
          }
          if (this.create.temp.rtime == '' || this.create.temp.rtime == null) {
            this.create.temp.rtime = ''
          }
          for (let i = 0; i < this.table.list.length; i++) {
            if (this.create.temp.sort == this.table.list[i].sort) {
              if (this.create.temp.myId !== this.table.list[i].myId) {
                this.$message({
                  type: 'error',
                  message: this.$t('message.msg150'),
                  duration: 2000
                })
                return false
              }
            }
          }

          var isInteger = /^\d+$/
          if (this.create.temp.sort !== '') {
            if (!isInteger.test(parseFloat(this.create.temp.sort))) {
              this.$message({
                type: 'error',
                message: this.$t('message.msg151'),
                duration: 2000
              })
              return false
            }
          }

          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)

          console.log(this.create.temp)

          var ztlasArr = [
            {
              bname: '',
              id: this.create.temp.useinbarid
            }
          ]

          this.transferbarsList.forEach(function (item) {
            if (item.id == ztlasArr[0].id) {
              ztlasArr[0].bname = item.bname
            }
          })

          console.log('ztlasArr', ztlasArr)

          var ssss_data = {
            common: {
              returnmap: '0'
            },
            data: [
              {
                name: 'insertRemainplan',
                type: 'e',
                parammaps: {
                  pastureid: Cookies.get('pastureid'),
                  sort: this.create.temp.sort,
                  tmrid: this.create.temp.tmrid,
                  tmrcode: this.create.temp.tmrcode,
                  enable: this.create.temp.enable,
                  times: this.create.temp.times,
                  lppid: this.create.temp.lppid,
                  lppcode: this.create.temp.lppcode,
                  rtime: this.create.temp.rtime,
                  treatmethod: this.create.temp.treatmethod
                }
              },
              {
                name: 'insertSpotList',
                resultmaps: {
                  list: this.barsNamesIdTempArr
                },
                children: [
                  {
                    name: 'insertRpdetail',
                    type: 'e',
                    parammaps: {
                      pastureid: Cookies.get('pastureid'),
                      bigid: '@insertRemainplan.LastInsertId',
                      barid: '@insertSpotList.id',
                      bar: '@insertSpotList.bname',
                      type: 0
                    }
                  }
                ]
              },
              {
                name: 'insertRpdetail',
                type: 'e',
                parammaps: {
                  pastureid: '1647917519',
                  bigid: '@insertRemainplan.LastInsertId',
                  barid: ztlasArr[0].id,
                  bar: ztlasArr[0].bname,
                  type: 1
                }
              }
            ]
          }

          // this.requestParam.common = { 'returnmap': '0' }
          // this.requestParam.data = []
          // this.requestParam.data[0] = { 'name': 'insertRemainplan', 'type': 'e', 'parammaps': {
          //   pastureid: Cookies.get('pastureid'),
          //   sort: this.create.temp.sort,
          //   tmrid: this.create.temp.tmrid,
          //   tmrcode: this.create.temp.tmrcode,
          //   enable: this.create.temp.enable,
          //   times: this.create.temp.times,
          //   lppid: this.create.temp.lppid,
          //   lppcode: this.create.temp.lppcode,
          //   rtime: this.create.temp.rtime,
          //   treatmethod: this.create.temp.treatmethod
          // }}
          // this.requestParam.data[1] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.barsNamesIdTempArr }}
          // this.requestParam.data[1].children = []
          // this.requestParam.data[1].children[0] = { 'name': 'insertRpdetail', 'type': 'e', 'parammaps': {
          //   pastureid: Cookies.get('pastureid'),
          //   bigid: '@insertRemainplan.LastInsertId',
          //   barid: '@insertSpotList.id',
          //   bar: '@insertSpotList.bname',
          //   type: 0
          // }}
          // this.requestParam.data[2] = { 'name': 'insertSpotList2', 'resultmaps': { 'list': this.useinbarNamesIdTempArr }}
          // this.requestParam.data[2].children = []
          // this.requestParam.data[2].children[0] = { 'name': 'insertRpdetail', 'type': 'e', 'parammaps': {
          //   pastureid: Cookies.get('pastureid'),
          //   bigid: '@insertRemainplan.LastInsertId',
          //   barid: '@insertSpotList2.id',
          //   bar: '@insertSpotList2.bname',
          //   type: 1
          // }}

          ExecDataByConfig(ssss_data).then((response) => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({
                title: this.$t('driver.saveFail'),
                message: response.data,
                type: 'warning',
                duration: 2000
              })
            } else {
              this.$notify({
                title: this.$t('common.succes'),
                message: this.$t('driver.saveSuccess'),
                type: 'success',
                duration: 2000
              })
              this.create.dialogFormVisible = false
              this.getList()
              this.dropState = false
            }
          })
        }
      })
    },

    createCancel(row) {
      console.log('点击了新增取消')
      this.dropState = false
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.myId === this.table.list[i].myId) {
          var listIndex = this.table.list.indexOf(this.table.list[i])
        }
        if (listIndex > -1) {
          this.table.list.splice(listIndex, 1)
          return
        }
      }
    },

    // 模板编辑
    // handleUpdate(row) {
    //   for (let i = 0; i < this.table.list.length; i++) {
    //     if (this.table.list[i].Edit == true) {
    //       this.$message({ type: 'error', message: this.$t('driver.messageNote'), duration: 2000 })
    //       return false
    //     }
    //   }
    //   console.log(row, '=========')
    //   // 编辑true,不可编辑false
    //   row.Edit = true
    //   row.NoEdit = false
    //   // 新增false,编辑false,编辑保存true
    //   row.isCreate = false
    //   row.isUpdate = false
    //   row.isUpdateSave = true
    //   row.temp = {}
    //   row.temp2 = {}
    //   if (row.useinbarid == '0') { row.useinbarid = [] }
    //   if (row.barid == undefined) { row.barid = [] }
    //   if (row.tmrid == undefined) { row.tmrid = '' }
    //   if (row.times == undefined) { row.times = '' }

    //   if (row.treatmethod == undefined) { row.treatmethod = '' }
    //   // this.getCarFollowParm.parammaps.times = row.times
    //   if (row.times == '第一班') {
    //     this.getCarFollowParm.parammaps.times = 1
    //     row.times = '1'
    //   } else if (row.times == '第二班') {
    //     this.getCarFollowParm.parammaps.times = 2
    //     row.times = '2'
    //   } else if (row.times == '第三班') {
    //     this.getCarFollowParm.parammaps.times = 3
    //     row.times = '3'
    //   } else if (row.times == '第四班') {
    //     this.getCarFollowParm.parammaps.times = 4
    //     row.times = '4'
    //   } else if (row.times == '第五班') {
    //     this.getCarFollowParm.parammaps.times = 5
    //     row.times = '5'
    //   }
    //   GetDataByName(this.getCarFollowParm).then(response => {
    //     console.log('撒料计划车次跟随列表数据', response.data.list)
    //     if (response.data.list !== null) {
    //       this.carFollowList = response.data.list
    //     }
    //   })
    //   console.log(row, '====')
    //   if (row.lppcode == undefined) {
    //     this.$set(row, 'lppid', '')
    //   }

    //   this.getTransferbarsList()
    //   // row.barid = row.qstrids.split(',')
    //   // row.useinbarid = row.hstrids.split(',')
    //   var arr3 = []
    //   for (let i = 0; i < row.barid.length; i++) {
    //     arr3.push(this.barsList.find(obj => obj.id == row.barid[i]))
    //   }
    //   this.barsNamesIdTempArr = arr3
    //   var arr4 = []
    //   setTimeout(() => {
    //     for (let i = 0; i < row.useinbarid.length; i++) {
    //       arr4.push(this.transferbarsList.find(obj => obj.id == row.useinbarid[i]))
    //     }
    //   }, 500)
    //   this.useinbarNamesIdTempArr = arr4
    //   console.log(this.useinbarNamesIdTempArr, 'this.useinbarNamesIdTempArr')
    //   this.dropState = true
    // },

    // 编辑
    handleUpdate(row) {
      console.log('点击了编辑', row)
      this.create.dialogStatus = 'update'
      this.dialogFull = false
      this.create.dialogFormVisible = true
      this.getCarFollowParm.parammaps.times = row.times
      this.getCarFollowList()

      row.temp = {}
      row.temp2 = {}

      if (row.treatmethod == '继续饲喂') {
        this.isDis = true
      } else {
        this.isDis = false
      }

      // if (row.useinbarid == '0') { row.useinbarid = "" }
      if (row.barid == undefined) {
        row.barid = []
      }
      if (row.tmrid == undefined) {
        row.tmrid = ''
      }
      if (row.times == undefined) {
        row.times = ''
      }

      if (row.treatmethod == undefined) {
        row.treatmethod = ''
      }
      // this.getCarFollowParm.parammaps.times = row.times
      if (row.times == '第一班') {
        this.getCarFollowParm.parammaps.times = 1
        row.times = '1'
      } else if (row.times == '第二班') {
        this.getCarFollowParm.parammaps.times = 2
        row.times = '2'
      } else if (row.times == '第三班') {
        this.getCarFollowParm.parammaps.times = 3
        row.times = '3'
      } else if (row.times == '第四班') {
        this.getCarFollowParm.parammaps.times = 4
        row.times = '4'
      } else if (row.times == '第五班') {
        this.getCarFollowParm.parammaps.times = 5
        row.times = '5'
      }
      GetDataByName(this.getCarFollowParm).then((response) => {
        console.log('撒料计划车次跟随列表数据', response.data.list)
        if (response.data.list !== null) {
          this.carFollowList = response.data.list
        } else {
          this.carFollowList = []
        }
      })
      if (this.carFollowList.length > 0) {
        if (
          this.carFollowList.find((obj) => obj.id == row.lppid).lppcode ==
          undefined
        ) {
          this.$set(row, 'lppid', '')
        }
      } else {
        this.$set(row, 'lppid', '')
      }

      if (row.lppcode == undefined) {
        this.$set(row, 'lppid', '')
      }

      this.getTransferbarsList()
      row.barid = row.qstrids.split(',')
      row.useinbarid = row.hstrids

      if (row.useinbarid == '0') {
        row.useinbarid = ''
      }

      var arr3 = []
      for (let i = 0; i < row.barid.length; i++) {
        arr3.push(this.barsList.find((obj) => obj.id == row.barid[i]))
      }
      this.barsNamesIdTempArr = arr3
      this.barSortList = arr3
      var arr4 = []

      // setTimeout(() => {
      //   for (let i = 0; i < row.useinbarid.length; i++) {
      //     arr4.push(this.transferbarsList.find(obj => obj.id == row.useinbarid[i]))
      //   }
      // }, 500)

      // this.useinbarNamesIdTempArr = arr4
      // console.log(this.useinbarNamesIdTempArr, 'this.useinbarNamesIdTempArr')
      this.dropState = true

      this.create.temp = Object.assign({}, row)
    },

    // updateData(row) {
    //   console.log('点击了编辑保存', row)
    //   console.log(this.useinbarNamesIdTempArr, 'this.useinbarNamesIdTempArr========')
    //   if (row.rtime == null || row.rtime == 'null') {
    //     row.rtime = ''
    //   }
    //   if (row.barid == '' && row.tmrid == '' && row.times == '' && row.treatmethod == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg183'), duration: 2000 })
    //     return false
    //   } else if (row.tmrid == '' && row.times == '' && row.treatmethod == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg184'), duration: 2000 })
    //     return false
    //   } else if (row.times == '' && row.treatmethod == '') {
    //     this.$message({ type: 'error', message:this.$t('message.msg189'), duration: 2000 })
    //     return false
    //   } else if (row.barid == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg186'), duration: 2000 })
    //     return false
    //   } else if (row.tmrid == '') {
    //     this.$message({ type: 'error', message:  this.$t('message.msg147'), duration: 2000 })
    //     return false
    //   } else if (row.times == '') {
    //     this.$message({ type: 'error', message:  this.$t('message.msg148'), duration: 2000 })
    //     return false
    //   } else if (row.treatmethod == '') {
    //     this.$message({ type: 'error', message: this.$t('message.msg187'), duration: 2000 })
    //     return false
    //   }
    //   if (row.treatmethod !== '' && row.treatmethod == '转投剩料') {
    //     if (row.useinbarid == '') {
    //       this.$message({ type: 'error', message: this.$t('message.msg188'), duration: 2000 })
    //       return false
    //     }
    //   }
    //   if (row.treatmethod !== '' && row.treatmethod == '继续饲喂') {
    //     row.useinbarid = '0'
    //   }
    //   if (row.rtime == '' || row.rtime == null) {
    //     row.rtime = ''
    //   }
    //   for (let i = 0; i < this.table.list.length; i++) {
    //     if (row.sort == this.table.list[i].sort) {
    //       if (row.id !== this.table.list[i].id) {
    //         this.$message({ type: 'error', message:  this.$t('message.msg150'), duration: 2000 })
    //         return false
    //       }
    //     }
    //   }
    //   var isInteger = /^\d+$/
    //   if (row.sort !== '') {
    //     if (!isInteger.test(parseFloat(row.sort))) {
    //       this.$message({ type: 'error', message:  this.$t('message.msg151'), duration: 2000 })
    //       return false
    //     }
    //   }
    //   if (row.sort == '' || row.sort == 0) {
    //     this.$message({ type: 'error', message:  this.$t('message.msg146'), duration: 2000 })
    //     return false
    //   }
    //   if (row.times == '第一班') {
    //     row.times = 1
    //   } else if (row.times == '第二班') {
    //     row.times = 2
    //   } else if (row.times == '第三班') {
    //     row.times = 3
    //   } else if (row.times == '第四班') {
    //     row.times = 4
    //   } else if (row.times == '第五班') {
    //     row.times = 5
    //   }
    //   this.isokDisable = true
    //   setTimeout(() => {
    //     this.isokDisable = false
    //   }, 1000)
    //   this.requestParam = {}
    //   this.requestParam.common = { 'returnmap': '0' }
    //   this.requestParam.data = []
    //   this.requestParam.data[0] = { 'name': 'updateRemainplan', 'type': 'e', 'parammaps': {
    //     pastureid: row.pastureid,
    //     id: row.id,
    //     sort: row.sort,
    //     tmrid: row.tmrid,
    //     tmrcode: row.tmrcode,
    //     enable: row.enable,
    //     times: row.times,
    //     lppid: row.lppid,
    //     lppcode: row.lppcode,
    //     rtime: row.rtime,
    //     treatmethod: row.treatmethod
    //   }}
    //   this.requestParam.data[1] = { 'name': 'deleteRpdetail', 'type': 'e', 'parammaps': {
    //     pastureid: row.pastureid,
    //     bigid: row.id
    //   }}
    //   this.requestParam.data[2] = { 'name': 'insertSpotList2', 'resultmaps': { 'list': this.barsNamesIdTempArr }}
    //   this.requestParam.data[2].children = []
    //   this.requestParam.data[2].children[0] = { 'name': 'insertRpdetail', 'type': 'e', 'parammaps': {
    //     pastureid: row.pastureid,
    //     bigid: row.id,
    //     barid: '@insertSpotList2.id',
    //     bar: '@insertSpotList2.bname',
    //     type: 0
    //   }}
    //   this.requestParam.data[3] = { 'name': 'insertSpotList3', 'resultmaps': { 'list': this.useinbarNamesIdTempArr }}
    //   this.requestParam.data[3].children = []
    //   this.requestParam.data[3].children[0] = { 'name': 'insertRpdetail', 'type': 'e', 'parammaps': {
    //     pastureid: row.pastureid,
    //     bigid: row.id,
    //     barid: '@insertSpotList3.id',
    //     bar: '@insertSpotList3.bname',
    //     type: 1
    //   }}
    //   ExecDataByConfig(this.requestParam).then(response => {
    //     console.log('新增保存发送参数', this.requestParam)
    //     if (response.msg === 'fail') {
    //       this.$notify({ title: this.$t('driver.saveFail'), message: response.data, type: 'warning', duration: 2000 })
    //     } else {
    //       this.$notify({ title: this.$t('common.succes'), message: this.$t('driver.saveSuccess'), type: 'success', duration: 2000 })
    //       this.getList()
    //       this.dropState = false
    //     }
    //   })

    // },

    updateData() {
      console.log('点击了编辑保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate((valid) => {
        if (valid) {
          if (
            this.create.temp.rtime == null ||
            this.create.temp.rtime == 'null'
          ) {
            this.create.temp.rtime = ''
          }
          if (
            this.create.temp.barid == '' &&
            this.create.temp.tmrid == '' &&
            this.create.temp.times == '' &&
            this.create.temp.treatmethod == ''
          ) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg183'),
              duration: 2000
            })
            return false
          } else if (
            this.create.temp.tmrid == '' &&
            this.create.temp.times == '' &&
            this.create.temp.treatmethod == ''
          ) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg184'),
              duration: 2000
            })
            return false
          } else if (
            this.create.temp.times == '' &&
            this.create.temp.treatmethod == ''
          ) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg189'),
              duration: 2000
            })
            return false
          } else if (this.create.temp.barid == '') {
            this.$message({
              type: 'error',
              message: this.$t('message.msg186'),
              duration: 2000
            })
            return false
          } else if (this.create.temp.tmrid == '') {
            this.$message({
              type: 'error',
              message: this.$t('message.msg147'),
              duration: 2000
            })
            return false
          } else if (this.create.temp.times == '') {
            this.$message({
              type: 'error',
              message: this.$t('message.msg148'),
              duration: 2000
            })
            return false
          } else if (this.create.temp.treatmethod == '') {
            this.$message({
              type: 'error',
              message: this.$t('message.msg187'),
              duration: 2000
            })
            return false
          }
          if (
            this.create.temp.treatmethod !== '' &&
            this.create.temp.treatmethod == '转投剩料'
          ) {
            if (this.create.temp.useinbarid == '') {
              this.$message({
                type: 'error',
                message: this.$t('message.msg188'),
                duration: 2000
              })
              return false
            }
          }
          if (
            this.create.temp.treatmethod !== '' &&
            this.create.temp.treatmethod == '继续饲喂'
          ) {
            this.create.temp.useinbarid = '0'
          }
          if (this.create.temp.rtime == '' || this.create.temp.rtime == null) {
            this.create.temp.rtime = ''
          }
          for (let i = 0; i < this.table.list.length; i++) {
            if (this.create.temp.sort == this.table.list[i].sort) {
              if (this.create.temp.id !== this.table.list[i].id) {
                this.$message({
                  type: 'error',
                  message: this.$t('message.msg150'),
                  duration: 2000
                })
                return false
              }
            }
          }
          var isInteger = /^\d+$/
          if (this.create.temp.sort !== '') {
            if (!isInteger.test(parseFloat(this.create.temp.sort))) {
              this.$message({
                type: 'error',
                message: this.$t('message.msg151'),
                duration: 2000
              })
              return false
            }
          }
          if (this.create.temp.sort == '' || this.create.temp.sort == 0) {
            this.$message({
              type: 'error',
              message: this.$t('message.msg146'),
              duration: 2000
            })
            return false
          }
          if (this.create.temp.times == '第一班') {
            this.create.temp.times = 1
          } else if (this.create.temp.times == '第二班') {
            this.create.temp.times = 2
          } else if (this.create.temp.times == '第三班') {
            this.create.temp.times = 3
          } else if (this.create.temp.times == '第四班') {
            this.create.temp.times = 4
          } else if (this.create.temp.times == '第五班') {
            this.create.temp.times = 5
          }
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)

          var ztlasArr2 = [
            {
              bname: '',
              id: this.create.temp.useinbarid
            }
          ]

          this.transferbarsList.forEach(function (item) {
            if (item.id == ztlasArr2[0].id) {
              ztlasArr2[0].bname = item.bname
            }
          })

          console.log('ztlasArr2', ztlasArr2)

          var ssss_data2 = {
            common: {
              returnmap: '0'
            },
            data: [
              {
                name: 'updateRemainplan',
                type: 'e',
                parammaps: {
                  pastureid: this.create.temp.pastureid,
                  id: this.create.temp.id,
                  sort: this.create.temp.sort,
                  tmrid: this.create.temp.tmrid,
                  tmrcode: this.create.temp.tmrcode,
                  enable: this.create.temp.enable,
                  times: this.create.temp.times,
                  lppid: this.create.temp.lppid,
                  lppcode: this.create.temp.lppcode,
                  rtime: this.create.temp.rtime,
                  treatmethod: this.create.temp.treatmethod
                }
              },
              {
                name: 'deleteRpdetail',
                type: 'e',
                parammaps: {
                  pastureid: this.create.temp.pastureid,
                  bigid: this.create.temp.id
                }
              },
              {
                name: 'insertSpotList2',
                resultmaps: {
                  list: this.barsNamesIdTempArr
                },
                children: [
                  {
                    name: 'insertRpdetail',
                    type: 'e',
                    parammaps: {
                      pastureid: this.create.temp.pastureid,
                      bigid: this.create.temp.id,
                      barid: '@insertSpotList2.id',
                      bar: '@insertSpotList2.bname',
                      type: 0
                    }
                  }
                ]
              },
              {
                name: 'insertRpdetail',
                type: 'e',
                parammaps: {
                  pastureid: this.create.temp.pastureid,
                  bigid: this.create.temp.id,

                  barid: ztlasArr2[0].id,
                  bar: ztlasArr2[0].bname,
                  type: 1
                }
              }
            ]
          }

          // this.requestParam = {}
          // this.requestParam.common = { 'returnmap': '0' }
          // this.requestParam.data = []
          // this.requestParam.data[0] = { 'name': 'updateRemainplan', 'type': 'e', 'parammaps': {
          //   pastureid: this.create.temp.pastureid,
          //   id: this.create.temp.id,
          //   sort: this.create.temp.sort,
          //   tmrid: this.create.temp.tmrid,
          //   tmrcode: this.create.temp.tmrcode,
          //   enable: this.create.temp.enable,
          //   times: this.create.temp.times,
          //   lppid: this.create.temp.lppid,
          //   lppcode: this.create.temp.lppcode,
          //   rtime: this.create.temp.rtime,
          //   treatmethod: this.create.temp.treatmethod
          // }}
          // this.requestParam.data[1] = { 'name': 'deleteRpdetail', 'type': 'e', 'parammaps': {
          //   pastureid: this.create.temp.pastureid,
          //   bigid: this.create.temp.id
          // }}
          // this.requestParam.data[2] = { 'name': 'insertSpotList2', 'resultmaps': { 'list': this.barsNamesIdTempArr }}
          // this.requestParam.data[2].children = []
          // this.requestParam.data[2].children[0] = { 'name': 'insertRpdetail', 'type': 'e', 'parammaps': {
          //   pastureid: this.create.temp.pastureid,
          //   bigid: this.create.temp.id,
          //   barid: '@insertSpotList2.id',
          //   bar: '@insertSpotList2.bname',
          //   type: 0
          // }}
          // // this.requestParam.data[3] = { 'name': 'insertSpotList3', 'resultmaps': { 'list': this.useinbarNamesIdTempArr }}

          // this.requestParam.data[3] = { 'name': 'insertSpotList3', 'resultmaps': { 'list': this.barsNamesIdTempArr }}

          // this.requestParam.data[3].children = []
          // this.requestParam.data[3].children[0] = { 'name': 'insertRpdetail', 'type': 'e', 'parammaps': {
          //   pastureid: this.create.temp.pastureid,
          //   bigid: this.create.temp.id,
          //   barid: '@insertSpotList3.id',
          //   bar: '@insertSpotList3.bname',
          //   type: 1
          // }}

          ExecDataByConfig(ssss_data2).then((response) => {
            console.log('保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({
                title: this.$t('driver.saveFail'),
                message: response.data,
                type: 'warning',
                duration: 2000
              })
            } else {
              this.$notify({
                title: this.$t('common.succes'),
                message: this.$t('driver.saveSuccess'),
                type: 'success',
                duration: 2000
              })
              this.create.dialogFormVisible = false
              this.getList()
              this.dropState = false
            }
          })
        }
      })
    },

    updateCancel(row) {
      console.log('点击了编辑取消')
      // 编辑false,不可编辑true
      row.Edit = false
      row.NoEdit = true
      // 新增false,编辑true,编辑保存false
      row.isCreate = false
      row.isUpdate = true
      row.isUpdateSave = false
      this.getList()
      this.dropState = false
    },

    handleSelect(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    // 行内删除
    handleRowDelete(row) {
      console.log(row, '点击了行删除')
      MessageBox.confirm(this.$t('common.delMsg'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning'
      })
        .then(() => {
          this.selectList = []
          this.requestParam = {}
          this.requestParam.name = 'deleteRemainplan'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.pastureid = row.pastureid
          this.requestParam.parammaps.id = row.id
          PostDataByName(this.requestParam).then((response) => {
            if (response.msg === 'fail') {
              this.$notify({
                title: this.$t('common.delfail'),
                message: response.data,
                type: 'warning',
                duration: 2000
              })
            } else {
              this.$notify({
                title: this.$t('common.succes'),
                message: this.$t('common.delSuccess'),
                type: 'success',
                duration: 2000
              })
              this.getList()
            }
          })
        })
        .catch(() => {
          this.$message({
            type: 'info',
            message: this.$t('common.cancelMsg')
          })
        })
    },
    // 减少车次
    form_delete() {
      if (this.selectList.length == 0) {
        this.$message({
          type: 'error',
          message: this.$t('message.msg12'),
          duration: 2000
        })
      } else {
        MessageBox.confirm(
          this.$t('message.msg29') +
            this.selectList.length +
            this.$t('message.msg31'),
          {
            confirmButtonText: this.$t('common.confirm'),
            cancelButtonText: this.$t('common.cancel'),
            type: 'warning'
          }
        ).then(() => {
          console.log(this.selectList)
          this.requestParam.common = {
            returnmap: '0'
          }
          this.requestParam.data = []
          this.requestParam.data[0] = {
            name: 'insertSpotList',
            resultmaps: {
              list: this.selectList
            }
          }
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = {
            name: 'deleteRemainplan',
            type: 'e',
            parammaps: {
              id: '@insertSpotList.id',
              pastureid: '@insertSpotList.pastureid'
            }
          }
          ExecDataByConfig(this.requestParam).then((response) => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({
                title: this.$t('common.delfail'),
                message: response.data,
                type: 'warning',
                duration: 2000
              })
            } else {
              this.$notify({
                title: '',
                message: this.$t('common.delSuccess'),
                type: 'success',
                duration: 2000
              })
              this.getList()
            }
          })
        })
      }
    },
    // 校验
    handleCheck() {
      console.log('点击了校验')
      this.check.dialogStatus = 'check'
      this.check.dialogFormVisible = true
      this.getCheckList()
    },
    getCheckList() {
      GetDataByName(this.check.getCheckParm).then((response) => {
        if (response.data.list[0].bnames !== undefined) {
          this.check.temp.isDistribution = 0
          this.check.temp.bnames = response.data.list[0].bnames
        } else {
          this.check.temp = {}
          this.check.temp.isDistribution = 1
        }
      })
    },
    // 历史记录
    handleHistoryRecords() {
      console.log('点击了历史记录')
      this.dialogFull = false
      this.history.dialogStatus = 'history'
      this.history.dialogFormVisible = true
      this.getDateList()
    },
    // 历史时间
    getDateList() {
      GetDataByName(this.history.getdataDateParm).then((response) => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.history.getdataListParm.parammaps.date =
            response.data.list[0].maxdate
          this.getHistoryList()
        } else {
          this.history.getdataListParm.parammaps.date = ''
        }
      })
    },
    changeDate() {
      this.getHistoryList()
    },
    // 应用
    handleApplication() {
      console.log('点击了应用')
      MessageBox.confirm(
        this.$t('message.msg58') +
          this.history.getdataListParm.parammaps.date +
          this.$t('message.msg59'),
        {
          confirmButtonText: this.$t('common.confirm'),
          cancelButtonText: this.$t('common.cancel'),
          type: 'warning'
        }
      )
        .then(() => {
          this.requestParam.name = 'applyFPdate'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.pastureid = Cookies.get('pastureid')
          this.requestParam.parammaps.date =
            this.history.getdataListParm.parammaps.date
          PostDataByName(this.requestParam).then((response) => {
            if (response.msg === 'fail') {
              this.$notify({
                title: this.$t('driver.saveFail'),
                message: response.data,
                type: 'warning',
                duration: 2000
              })
            } else {
              this.$notify({
                title: this.$t('common.succes'),
                message: this.$t('driver.saveSuccess'),
                type: 'success',
                duration: 2000
              })
              this.getHistoryIsDisplay()
              this.getList()
            }
          })
        })
        .catch(() => {
          this.$message({
            type: 'info',
            message: this.$t('message.msg41')
          })
        })
    },
    getHistoryList() {
      this.history.listLoading = true
      GetDataByName(this.history.getdataListParm).then((response) => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          console.log('table数据', response.data.list)
          this.history.list = response.data.list
          this.history.pageNum = response.data.pageNum
          this.history.pageSize = response.data.pageSize
          this.history.total = response.data.total
        } else {
          this.history.list = []
        }
        setTimeout(() => {
          this.history.listLoading = false
        }, 100)
      })
    },
    handleTakeEffect() {
      if (this.selectList.length == 0) {
        this.$message({
          type: 'error',
          message: this.$t('message.msg12'),
          duration: 2000
        })
      } else {
        MessageBox.confirm(
          this.$t('message.msg29') +
            this.selectList.length +
            this.$t('message.msg141'),
          {
            confirmButtonText: this.$t('common.confirm'),
            cancelButtonText: this.$t('common.cancel'),
            type: 'warning'
          }
        ).then(() => {
          for (let i = 0; i < this.selectList.length; i++) {
            // this.$set(this.selectList[i], 'enable', '1')
            this.selectList[i].enable = 1
          }
          console.log('生效', this.selectList)
          this.requestParam.common = {
            returnmap: '0'
          }
          this.requestParam.data = []
          this.requestParam.data[0] = {
            name: 'insertSpotList',
            resultmaps: {
              list: this.selectList
            }
          }
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = {
            name: 'updateRemainplanEnable',
            type: 'e',
            parammaps: {
              enable: '@insertSpotList.enable',
              id: '@insertSpotList.id',
              pastureid: '@insertSpotList.pastureid'
            }
          }
          ExecDataByConfig(this.requestParam).then((response) => {
            console.log('生效保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({
                title: this.$t('message.msg11'),
                message: response.data,
                type: 'warning',
                duration: 2000
              })
            } else {
              this.$notify({
                title: '',
                message: this.$t('message.msg10'),
                type: 'success',
                duration: 2000
              })
              this.getList()
            }
          })
        })
      }
    },
    handleDisable() {
      if (this.selectList.length == 0) {
        this.$message({
          type: 'error',
          message: this.$t('message.msg12'),
          duration: 2000
        })
      } else {
        MessageBox.confirm(
          this.$t('message.msg29') +
            this.selectList.length +
            this.$t('message.msg30'),
          {
            confirmButtonText: this.$t('common.confirm'),
            cancelButtonText: this.$t('common.cancel'),
            type: 'warning'
          }
        ).then(() => {
          for (let i = 0; i < this.selectList.length; i++) {
            // this.$set(this.selectList[i], 'enable', '1')
            this.selectList[i].enable = 0
          }
          console.log('禁用', this.selectList)
          this.requestParam.common = {
            returnmap: '0'
          }
          this.requestParam.data = []
          this.requestParam.data[0] = {
            name: 'insertSpotList',
            resultmaps: {
              list: this.selectList
            }
          }
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = {
            name: 'updateRemainplanEnable',
            type: 'e',
            parammaps: {
              enable: '@insertSpotList.enable',
              id: '@insertSpotList.id',
              pastureid: '@insertSpotList.pastureid'
            }
          }
          ExecDataByConfig(this.requestParam).then((response) => {
            console.log('禁用保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({
                title: this.$t('message.msg13'),
                message: response.data,
                type: 'warning',
                duration: 2000
              })
            } else {
              this.$notify({
                title: '',
                message: this.$t('message.msg15'),
                type: 'success',
                duration: 2000
              })
              this.getList()
            }
          })
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.search {
  clear: both;
}

.table {
  margin-top: 10px;
}
</style>
